<?php
/**
* @version 			SEBLOD 3.x Core
* @package			SEBLOD (App Builder & CCK) // SEBLOD nano (Form Builder)
* @url				http://www.seblod.com
* @editor			Octopoos - www.octopoos.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
**/

// No Direct Access
defined( '_JEXEC' ) or die;

// Plugin
class plgCCK_FieldPulsarMultipleAutocomplete extends JCckPluginField
{
	protected static $type		=	'pulsarMultipleAutocomplete';
	protected static $path;
	
	// -------- -------- -------- -------- -------- -------- -------- -------- // Construct
	
	// onCCK_FieldConstruct
	public function onCCK_FieldConstruct( $type, &$data = array() )
	{
		if ( self::$type != $type ) {
			return;
		}
		parent::g_onCCK_FieldConstruct( $data );
	}
	
	// -------- -------- -------- -------- -------- -------- -------- -------- // Prepare
	
	// onCCK_FieldPrepareContent
	public function onCCK_FieldPrepareContent( &$field, $value = '', &$config = array() )
	{
		if ( self::$type != $field->type ) {
			return;
		}
		parent::g_onCCK_FieldPrepareContent( $field, $config );
		
		// Init
		$options2	=	JCckDev::fromJSON( $field->options2 );
		$divider	=	'';
		$lang_code	=	'';
		$value2		=	'';
		
		/* tmp */
		$jtext						=	$config['doTranslation'];
		$config['doTranslation']	=	0;
		/* tmp */

		// Prepare
		self::_languageDetection( $lang_code, $value2, $options2 );
		if ( $field->bool3 && !empty($value)) {
			// Set Multiple
			$divider	=	( trim($field->divider) != '' ) ? trim($field->divider) : ',';
			$field->divider = $divider;
			if ( $divider ) {
				$value	=	explode( $divider, $value );
			}
		}
		
		if ( $field->location ) {
			$attribs	=	explode( '||', $field->location );
			$attrib		=	count( $attribs );
		} else {
			$attribs	=	array();
			$attrib		=	0;
		}

		// echo $value;
		// exit;

		$text = '';
		if(!empty($value)){
			
			if($field->bool3 && is_array($value) && count($value)){
				foreach($value as $val){
					$this->prepareValue($field,$val,$initialDataVal,$initialDataStr,$text);
					$text .= ',';
				}
				$field->text = trim(substr($text,0,-1));
			}else{
				$this->prepareValue($field,$value,$initialDataVal,$initialDataStr,$text);
				$field->text = trim($text);
			}
		}
		
		// Set
		$field->value		=	$value;
		$field->value		=	( is_array( $field->value ) ) ? implode( $divider, array_map('trim',array_filter($field->value)) ) : $field->value;
		$field->typo_target	=	'text';
		
	}
	
	protected function _addCssAndScript($lang_code){
		$doc    =       JFactory::getDocument();
		$doc->addStyleSheet( self::$path.'assets/css/css_complete.css' );
		// add select2
		$doc->addStyleSheet( self::$path.'assets/css/select2.min.css' );
	
			
		$doc->addScript('/media/jui/js/jquery-noconflict.js');
		$doc->addScript(self::$path.'assets/js/select2.js');
		// here, had to change select2.js for mootools compatibility (think so, not sure),
		// line 5270 replace	$.fn.select2.amd = S2;
		// by 					jQuery.fn.select2.amd = S2;
	
		$doc->addScript(self::$path.'assets/js/i18n/'.$lang_code.'.js');
	}
	
	// onCCK_FieldPrepareForm
	public function onCCK_FieldPrepareForm( &$field, $value = '', &$config = array(), $inherit = array(), $return = false )
	{
		if ( self::$type != $field->type ) {
			return;
		}
		self::$path	=	parent::g_getPath( self::$type.'/' );
		parent::g_onCCK_FieldPrepareForm( $field, $config );
		
		// Init
		if ( count( $inherit ) ) {
			$id		=	( @$inherit['id'] != '' ) ? $inherit['id'] : $field->name;
			$name	=	( @$inherit['name'] != '' ) ? $inherit['name'] : $field->name;
		} else {
			$id		=	$field->name;
			$name	=	$field->name;
		}
		
		$value		=	( $value != '' ) ? $value : $field->defaultvalue;
		$value		=	( $value != ' ' ) ? $value : '';
		$value		=	htmlspecialchars( $value, ENT_QUOTES );
		
		// echo $value;
		// exit;

		// Init
		$options2	=	JCckDev::fromJSON( $field->options2 );
		$divider	=	'';
		$lang_code	=	'';
		$value2		=	'';
		
		/* tmp */
		$jtext						=	$config['doTranslation'];
//		$config['doTranslation']	=	0;
		/* tmp */
		
		// Prepare
		
		self::_languageDetection( $lang_code, $value2, $options2 );		
		
		if ( $field->bool3 && !empty($value)) {
			// Set Multiple
			$divider	=	( $field->divider != '' ) ? $field->divider : ',';
			if ( $divider ) {
				$value	=	explode( $divider, $value );
			}
		}
		
		// Validate
		$validate	=	'';
		if ( $config['doValidation'] > 1 ) {
			plgCCK_Field_ValidationRequired::onCCK_Field_ValidationPrepareForm( $field, $id, $config );
			parent::g_onCCK_FieldPrepareForm_Validation( $field, $id, $config );
			
			$validate	=	( count( $field->validate ) ) ? ' validate['.implode( ',', $field->validate ).']' : '';
		}
		
		// Prepare
		$class	=	'inputbox text'.$validate.' '.$field->css;
		$maxlen	=	( $field->maxlength > 0 ) ? 'maxlength="'.$field->maxlength.'" ' : '';
		$size	=	'size="'.$field->size.'" ';
		$style	=	( @$field->style ) ? 'style="'.$field->style.'" ' : '';
		
		$attr	=	'class="'.$class.'" '.$maxlen.$size.$style.$field->attributes;
		
		if ( $field->location ) {
			$attribs	=	explode( '||', $field->location );
			$attrib		=	count( $attribs );
		} else {
			$attribs	=	array();
			$attrib		=	0;
		}
		
		$label = array();
		$attr = '';
		
		$initialDataVal = $initialDataStr = '';

		// echo $value;
		// exit;

		if(!empty($value)){

			// echo $value.'<br/>';
			// echo $field->bool3.'<br/>';
			// exit;

			$initialDataVal = '[';
			// $initialDataVal = '';
			
			if($field->bool3 && is_array($value) && count($value)){
				
				foreach($value as $val){
					$this->prepareValue($field,$val,$initialDataVal,$initialDataStr);
				}
			}else{

				$this->prepareValue($field,$value,$initialDataVal,$initialDataStr);				

			}

			$initialDataVal = substr($initialDataVal,0, -1);
			// $initialDataVal .= substr($initialDataVal,0, -1);
			$initialDataVal .= ']';
			// $initialDataVal .= '';

			// echo $initialDataVal.'<br/>';
			// exit;

		}else{
			foreach ( $attribs as $k=>$a ) {
				$ka				=	'attr'.( $k + 1 );
				$attr	.=	' '.$a.'="'.( isset( $res->{$ka} ) ? $res->{$ka} : '' ).'"';
			
			}
		}
		
		// here check if multiple
		$name = $field->bool3 ? $name.'[]' : $name;
		$form	=	'<select id="'.$id.'" class="autocomplete_'.$field->id.'" name="'.$name.'" '.$attr.' ></select>';
		$location	=	JCckDev::fromSTRING( $field->location );
		$options2	=	JCckDev::fromJSON( $field->options2 );
		$where	=	$field->options;
		
		$placeholder    =       empty($options2['placeholder']) ? 'Selectionnez une option' : $options2['placeholder'];

		if ( $field->minlength == '' ) $field->minlength = 3;

		$is_in_seblod_list = (isset($config['formId']) && substr($config['formId'], 0, 12 ) === 'seblod_list_');	
		if(!$is_in_seblod_list){
			$this->_addCssAndScript($lang_code);
		}
		
		$doc    =       JFactory::getDocument();

		$script = '
				var field_' . $field->id . '_fieldid = '.$field->id.';
				
	jQuery(document).ready(function(){
    			jQuery(".autocomplete_'.$field->id.'").select2({
    				debug : true,
    				multiple: '. ($field->bool3 ? 'true' : 'false' ) .',
					minimumInputLength: '.$field->minlength.',
    				language:"'.$lang_code.'",
					placeholder: "'.$placeholder.'",
					allowClear: true,
					ajax: {
						url: "'. JURI::root().'index.php?option=com_ajax&plugin=autocompletemultiplepulsar&group=cck_field&format=json",
						type:"POST",
						dataType: "json",
						data: function(inputData){
							return {
								userInput:	inputData.term,
								fieldId: field_' . $field->id . '_fieldid
							};
						},
						
						 processResults: function (data, params) {
			                params.page = params.page || 1;
			
							// console.log(data);

			                // you should map the id and text attributes on version 4.0
			                var success = data["success"];
			                if(success){
						    	var data = data["data"][0];
						    	
						    	if(typeof data == "string"){
						    		data = JSON.parse(data);
						    	}
						    	// console.log("data now = "+data);
			                	var select2Data = jQuery.map(data, function (obj) { 

									if(typeof obj === "string" || obj instanceof String){

										var res = new Object();

										res.id = obj;
										res.text = obj;

										return res;

									} else if (obj instanceof Object && ("value" in obj)) {

			                	    	obj.id = obj.value;

			                	    	if(!("text" in obj)){
											obj.text = obj.value;
			                	    	}
			                	    	return obj;
									}
			                	    return obj;
			                	});
			                	// console.log("select2Data");
			                	console.log(select2Data);
			                }
			                return {
			                    results: select2Data
			                };
			            },
								

					}
	  			});
			';					

		if(count($value) && !empty($value)){
			$script .= 'jQuery(".autocomplete_'.$field->id.'").empty();';
				$script .= 'jQuery(".autocomplete_'.$field->id.'").append("'.$initialDataStr.'").val('.$initialDataVal.').trigger("change");';					
		}
		$script.= '
	  });
	  
				
				';
		if(!$is_in_seblod_list){
			$doc->addScriptDeclaration($script);
		}
		
						
		
		
		// Set
		if ( ! $field->variation ) {
			$field->form	=	$form;
			if ( $field->script ) {
				parent::g_addScriptDeclaration( $field->script );
			}
		} else {
			parent::g_getDisplayVariation( $field, $field->variation, $value, $value, $form, $id, $name, '<input' );
		}
		$field->value	=	$value;
		
		// Return
		if ( $return === true ) {
			return $field;
		}
	}
	
	// onCCK_FieldPrepareSearch
	public function onCCK_FieldPrepareSearch( &$field, $value = '', &$config = array(), $inherit = array(), $return = false )
	{
		if ( self::$type != $field->type ) {
			return;
		}
		
		// Init
		if ( $field->bool3 ) {
			$divider			=	$field->match_value ? $field->match_value : $field->divider;
			$field->match_value	=	$divider;
			if ( is_array( $value ) ) {
				$value	=	implode( $divider, $value );
			}
				
			$field->divider	=	$divider;
		} else {
			$field->match_value	=	$field->match_value ? $field->match_value : ',';
		}
		self::onCCK_FieldPrepareForm( $field, $value, $config, $inherit, $return );
		
		// Set
		$field->value	=	$value;
		
		// Return
		if ( $return === true ) {
			return $field;
		}
	}
	
	// onCCK_FieldPrepareStore
	public function onCCK_FieldPrepareStore( &$field, $value = '', &$config = array(), $inherit = array(), $return = false )
	{
		if ( self::$type != $field->type ) {
			return;
		}
		
		// Init
		if ( count( $inherit ) ) {
			$name	=	( @$inherit['name'] != '' ) ? $inherit['name'] : $field->name;
		} else {
			$name	=	$field->name;
		}
		
		// Prepare
		if ( $field->bool3 ) {
			// Set Multiple
			$divider	=	( $field->divider != '' ) ? $field->divider : ',';
			if ( $divider ) {
				$nb			=	count( $value );
				if ( is_array( $value ) && $nb > 0 ) {
					$value	=	implode( $divider, $value );
				}
			}
		}
		
		// Validate
		parent::g_onCCK_FieldPrepareStore_Validation( $field, $name, $value, $config );
		
		// Set or Return
		if ( $return === true ) {
			return $value;
		}
		$field->value	=	$value;
		parent::g_onCCK_FieldPrepareStore( $field, $name, $value, $config );
	}
	
	// -------- -------- -------- -------- -------- -------- -------- -------- // Render
	
	// onCCK_FieldRenderContent
	public static function onCCK_FieldRenderContent( $field, &$config = array() )
	{ 
		$ret = parent::g_onCCK_FieldRenderContent( $field, 'text' );

		return $ret;
	}
	
	// onCCK_FieldRenderForm
	public static function onCCK_FieldRenderForm( $field, &$config = array() )
	{
// 		// TODO clean this to check ALL jquery-ui and not only this specifiq path
// 		// a bit ugly, i've got to say, but still working for now
// 		$doc    =       JFactory::getDocument();
// 		$path = '/media/cck/js/jquery.ui.min.js';
// 		$newPath = self::$path.'assets/js/jquery-ui.js';
// 		// add this script in the path
// 		if( !isset($doc->_scripts[$path]) && !isset($doc->_scripts[str_replace('//', '\\', $path)]) && !isset($doc->_scripts[$newPath])){			
// 			$doc->addScript($newPath);
// 		}
// 		return parent::g_onCCK_FieldRenderForm( $field );
		
		
		// TODO clean this to check ALL jquery-ui and not only this specifiq path
		// a bit ugly, i've got to say, but still working for now
		$doc    =       JFactory::getDocument();
		$pathMin = '/media/cck/js/jquery.ui.min.js';
		$path = '/media/cck/js/jquery-ui.js';
		$newPath = self::$path.'assets/js/jquery-ui.js';
		
		// add this script in the path
		if( !isset($doc->_scripts[$pathMin]) && !isset($doc->_scripts[str_replace('//', '\\', $pathMin)]) && !isset($doc->_scripts[$path]) && !isset($doc->_scripts[str_replace('//', '\\', $path)]) && !isset($doc->_scripts[$newPath])){
			if(!file_exists(getcwd().$path)){
				if(!copy( __DIR__.DIRECTORY_SEPARATOR.'assets/js/jquery-ui.js', getcwd().$path))
					$doc->addScript($newPath);
			}else{
				$doc->addScript($path);
			}
		}
		return parent::g_onCCK_FieldRenderForm( $field );
	}
	
	public function onAjaxAutocompletemultiplepulsar()
	{
		$userInput = JRequest::getVar('userInput', 0);
		$fieldId = (int)JRequest::getVar('fieldId', 0);
		
		$where = ' WHERE a.id = '.$fieldId;
		$query  =       ' SELECT DISTINCT a.*, c.client,'
                		.       ' c.label as label2, c.variation, c.variation_override, c.required, c.required_alert, c.validation, c.validation_options, c.live, c.live_options, c.live_value, c.markup, c.markup_class, c.match_collection, c.match_mode, c.match_options, c.match_value, c.stage, c.access, c.restriction, c.restriction_options, c.computation, c.computation_options, c.conditional, c.conditional_options, c.position'
		                .       ' FROM #__cck_core_fields AS a '
                                .       ' LEFT JOIN #__cck_core_search_field AS c ON c.fieldid = a.id'
                        	.       ' LEFT JOIN #__cck_core_searchs AS b ON b.id = c.searchid'
				.       $where
				.       ' ORDER BY c.ordering ASC';

		$field = JCckDatabase::loadObject($query);

		
		
		self::$path	=	parent::g_getPath( self::$type.'/' );
		//parent::g_onCCK_FieldPrepareForm( $field, $config );
	

		$id		=	$field->name;
		$name	=	$field->name;
		$value	=	( $userInput != '' ) ? $userInput : $field->defaultvalue;
		
		// Validate
// 		$validate	=	'';
// 		if ( $config['doValidation'] > 1 ) {
// 			plgCCK_Field_ValidationRequired::onCCK_Field_ValidationPrepareForm( $field, $id, $config );
// 			$validate	=	( count( $field->validate ) ) ? ' validate['.implode( ',', $field->validate ).']' : '';
// 		}
	
		// Prepare
		$attr		=	array( 'option.attr'=>'data-cck' );
		$auto		=	1;
		$items		=	array();
		$opts		=	array();
		if ( $field->location ) {
			$attribs	=	explode( '||', $field->location );
			$attrib		=	count( $attribs );
		} else {
			$attribs	=	array();
			$attrib		=	0;
		}
		
		if ( trim( $field->selectlabel ) ) {
// 			if ( $config['doTranslation'] ) {
// 				$field->selectlabel	=	JText::_( 'COM_CCK_' . str_replace( ' ', '_', trim( $field->selectlabel ) ) );
// 			}
			if ( $attrib ) {
				$attr['attr']	=	'';
				foreach ( $attribs as $k=>$a ) {
					$attr['attr']	.=	' '.$a.'=""';
				}
				$opts[]	=	JHtml::_( 'select.option',  '', '- '.$field->selectlabel.' -', $attr );
			} else {
				$opts[]	=	JHtml::_( 'select.option',  '', '- '.$field->selectlabel.' -', 'value', 'text' );
			}
			$auto++;
		}
		$count2			=	JCck::getConfig_Param( 'development_attr', 6 );
		$opt_attr		=	'';
		$opt_attrs		=	array();
		$options2		=	JCckDev::fromJSON( $field->options2 );
		$optgroups		=	false;

		if ( $field->bool4 == 1 ) {
			$results	=	self::_getStaticOption( $field, $field->options, $config, $optgroups );
			foreach ( $results as $result ) {
				$opts[]	=	$result;
			}
		}

		// createquery, then execute it
		$items = $this->getItems($field,$value);

		if ( count( $items ) ) {
			$value = json_encode($items);
		}else{
			$value = null;
		}
		
// 		no static options for now
// 		if ( $field->bool4 == 2 ) {
// 			$results	=	self::_getStaticOption( $field, $field->options, $config );
// 			foreach ( $results as $result ) {
// 				$opts[]	=	$result;
// 			}
// 		}

			
		/* tmp */
		//$jtext						=	$config['doTranslation'];
		$config['doTranslation']	=	0;
		/* tmp */

		/*
		// Set
		if ( ! $field->variation ) {
			$field->form	=	$form;
			if ( $field->script ) {
				parent::g_addScriptDeclaration( $field->script );
			}
		} else {
			$options_2			=	self::_getOptionsList( $options2, $field->bool2, $lang_code );
			if ( $field->bool4 ) {
				$field->text	=	parent::g_getOptionText( $value, ( ( $field->options ) ? $field->options.'||'.$options_2 : $options_2 ), $divider, $config );
			} else {
				$field->text	=	parent::g_getOptionText( $value, $options_2, $divider, $config );
			}
			parent::g_getDisplayVariation( $field, $field->variation, $value, $field->text, $form, $id, $name, '<select', '', '', $config );
		}
*/
		/* tmp */
		//$config['doTranslation']	=	$jtext;
		/* tmp */
		
		$field->value	=	$value; 
	
		return $value;
	}
	
	// _languageDetection
	protected static function _languageDetection( &$lang_code, &$value, $options2 )
	{
		if ( @$options2['geoip'] && function_exists( 'geoip_country_code_by_name' ) ) {
			$lang_code	=	geoip_country_code_by_name( $_SERVER['REMOTE_ADDR'] );
		} else {
			jimport( 'joomla.language.helper' );
			$languages	=	JLanguageHelper::getLanguages( 'lang_code' );
			$lang_tag	=	JFactory::getLanguage()->getTag();
			$lang_code	=	( isset( $languages[$lang_tag] ) ) ? strtoupper( $languages[$lang_tag]->sef ) : '';
		}
		$value			=	str_replace( '[lang]', $lang_code, $value );
		$languages		=	explode( ',', @$options2['language_codes'] );
		if ( ! in_array( $lang_code, $languages ) ) {
			$lang_code	=	@$options2['language_default'] ? $options2['language_default'] : '';
		}
		$lang_code		=	strtolower( $lang_code );
	}
	
	protected function getQuery($field,$value,$withoutinput=false)
	{
		$count2			=	JCck::getConfig_Param( 'development_attr', 6 );
		$opt_attr		=	'';
		$opt_attrs		=	array();
		$options2		=	JCckDev::fromJSON( $field->options2 );
		$optgroups		=	false;

		if ( $field->bool2 == 0 ) {
			$opt_table			=	isset( $options2['table'] ) ? ' FROM '.$options2['table'] : '';
			$opt_name			=	isset( $options2['name'] ) ? $options2['name'] : '';
			$opt_value			=	isset( $options2['value'] ) ? $options2['value'] : '';

			if ( $count2 ) {
				for ( $i = 1; $i <= $count2; $i++ ) {
					$opt_attrs[]	=	( isset( $options2['attr'.$i] ) && $options2['attr'.$i] != '' ) ? $options2['attr'.$i] : '';
				}
			}
			$opt_where			=	@$options2['where'] != '' ? ' WHERE '.$options2['where']: '';
			$opt_orderby		=	@$options2['orderby'] != '' ? ' ORDER BY '.$options2['orderby'].' '.( ( @$options2['orderby_direction'] != '' ) ? $options2['orderby_direction'] : 'ASC' ) : '';
			$opt_limit			=	@$options2['limit'] > 0 ? ' LIMIT '.$options2['limit'] : '';

			// Language Detection
			$count2				=	count( $opt_attrs );
			$lang_code			=	'';
			self::_languageDetection( $lang_code, $value, $options2 );
			$opt_value			=	str_replace( '[lang]', $lang_code, $opt_value );
			
			$opt_name			=	str_replace( '[lang]', $lang_code, $opt_name );
			
			if(strpos($opt_value,' as ')){
				$pattern = "#(.*)(?:[\s]+)(?:as|AS)(?:[\s]+)([a-zA-Z_0-9]*)#";
				$replacement = " $1 AS value ";
				$opt_name = preg_replace($pattern, $replacement, $opt_name);
			}else{
				$opt_value .= " as value ";
			}
			
			if(strpos($opt_name,' as ')){
				$pattern = "#(.*)(?:[\s]+)(?:as|AS)(?:[\s]+)([a-zA-Z_0-9]*)#";
				$replacement = " $1 AS text ";
				$opt_name = preg_replace($pattern, $replacement, $opt_name);
			}else{
				$opt_name .= " as text ";
			}
			
			$opt_where			=	str_replace( '[lang]', $lang_code, $opt_where );
			$opt_orderby		=	str_replace( '[lang]', $lang_code, $opt_orderby );
			$opt_group			=	'';
			
			if ( $count2 ) {
				foreach ( $opt_attrs as $k=>$v ) {
					if ( $v != '' ) {
						$v			=	str_replace( '[lang]', $lang_code, $v ).' AS attr'.( $k + 1 );
						$opt_attr	.=	','.$v;
					}
				}
				if ( $opt_attr == ',' ) {
					$opt_attr	=	'';
				}
			}
			if ( $opt_name && $opt_value && $opt_table ) {
				$query			=	'SELECT '.$opt_name.','.$opt_value.$opt_attr.$opt_table.$opt_where.$opt_orderby.$opt_limit;
				$query			=	JCckDevHelper::replaceLive( $query );
			}
		} else {
			if ( @$options2['query'] != '' ) {
				// Language Detection
				$lang_code		=	'';
				self::_languageDetection( $lang_code, $value, $options2 );
				$query			=	str_replace( '[lang]', $lang_code, $options2['query'] );
				$query			=	JCckDevHelper::replaceLive( $query );
				
			}
		}
		
		$query = strtolower($query);

		// echo json_encode($withoutinput);

		if(!$withoutinput){

			if ( ( strpos( $query, ' inputdata ' ) !== false ) || ( strpos( $query, 'inputdata' ) !== false ) ) {
				$query = str_replace('inputdata', $value, $query);
			}
		}else{
//$query = 'select ctnorme.title as text, conorme.pk as value from #__cck_core as conorme inner join #__content as ctnorme on (conorme.cck like "norme" and conorme.pk = ctnorme.id and ctnorme.title like "%inputdata%" ) AND whatever = true';
//			$pattern = "#(?:.*)((\sWHERE\s|\sOR\s|\sAND\s)(.*)inputdata(.*))(\sWHERE\s|\sOR\s|\sAND\s)?(.*)#i";

			// $pattern = "/.*\\K\\s(?:WHERE|AND|OR)\\s.*?inputdata[^\\s)]*/i"; 
			$pattern = "/.*\\K\\s(?:WHERE|AND|OR)\\s.*?inputdata[^\\s)]*/i"; 

			preg_match($pattern,$query,$matches);

			// echo json_encode($matches).'<br/><br/>';

			if(count($matches)){
				$query = preg_replace($pattern,"",$query);
			}
		}
		return $query;
	}
	
	protected function getItems($field,$value)
	{
		$count2			=	JCck::getConfig_Param( 'development_attr', 6 );
		$opt_attr		=	'';
		$opt_attrs		=	array();
		$options2		=	JCckDev::fromJSON( $field->options2 );
		$optgroups		=	false;
		
		$query =  $this->getQuery($field,$value);
		
		if ( $field->bool2 == 0 ) {
			$items		=	JCckDatabase::loadObjectList( $query );
// 			if ( $config['client'] == '' || $config['client'] == 'dev' ) {
// 				$tables		=	JCckDatabaseCache::getTableList();
// 				$prefix		=	JFactory::getDbo()->getPrefix();
// 				$items		=	( in_array( str_replace( '#__', $prefix, $options2['table'] ), $tables ) ) ? JCckDatabase::loadObjectList( $query ) : array();
// 			} else {
// 				$items		=	JCckDatabase::loadObjectList( $query );
// 			}
		} else {
			if ( @$options2['query'] != '' ) {
				if ( ( strpos( $query, ' value ' ) !== false ) || ( strpos( $query, 'AS value' ) !== false ) || ( strpos( $query, ' value,' ) !== false ) ) {
					$items	=	JCckDatabase::loadObjectList( $query );
				} else {
					// return $query;
					$opts2	=	JCckDatabase::loadColumn( $query );
					return $opts2;
					$opts2	=	JCckDatabase::loadObjectList( $query );
					if ( count( $opts2 ) ) {
						$opts2	=	array_combine( array_values( $opts2 ), $opts2 );
					}
					$opts	=	array_merge( $opts, $opts2 );
				}
			}
			$opt_name	=	'text';
			$opt_value	=	'value';
			$opt_group	=	'optgroup';
		}

		return $items;	
	}
	
	// get text from Value
	protected function prepareValue($field,&$val,&$initialDataVal,&$initialDataStr,&$txt=''){
				

				$initialDataVal .= is_int($val) ? $val : '"'.$val.'"';
				$initialDataVal .= ',';
// echo '---'; 
// 				echo $val; 
// 				echo $initialDataVal; 

				// get query AND label and attr from the query o/
				$query = $this->getQuery($field, $val,true);

				// echo $val.'<br/><br/>'; 
				// echo $query.'<br/><br/>'; 
				// exit;
				
				// 			$pattern = "#(\w*)(?:[{\s}*]as[{\s}*]value[{\s|,}*])#";
				$pattern = "#([^\s&&^,]*)(?:[{\s}*]as[{\s}*]value[{\s|,}*])#";
				
				$matches = array();
				$r = preg_match($pattern, $query,$matches);

				// echo json_encode($matches).'<br/><br/>'; 
				// exit;

				// TODO check if not better to do a LIKE depending of the dataType , for now let's add quote systematically >__<

				if(count($matches)){
					if(stripos($matches[1],'group_concat') !== false){
						$pattern = "#group_concat\((.*)\)#i";
						$where = preg_replace($pattern, " WHERE $1 IN ( $val )", $matches[1]);
					}else{
						$where = ' where '.$matches[1].' = "'.$val. '"';
					}
				}

				if(stripos($query, "WHERE") !== false){
					$query = substr_replace($query, $where, stripos($query, 'where'));
				}else{
					if(stripos($query, "GROUP BY") !== false){
						$pattern = "#group by (.*)#i";
						$query = preg_replace($pattern, " $where group by $1", $query);
					}else{
						$query = $query . $where;
					}
				}

				// echo $query; 
				// exit;

				$db = JFactory::getDbo();
				$db->setQuery($query);
				$res = $db->loadObject();

				// echo $res->text; 
				// exit;

				if($res){
					$txt .= (isset($res->text) ? $res->text: $val);					
					$initialDataStr .= '<option value=\''.$val.'\'>'.(isset($res->text) ? $res->text: $val).'</option>';
					if(isset($attribs) && count($attribs))
						foreach ( $attribs as $k=>$a ) {
							$ka				=	'attr'.( $k + 1 );
							$attr	.=	' '.$a.'="'.( isset( $res->{$ka} ) ? $res->{$ka} : '' ).'"';
						}
				}
			}
}
?>
